package cn.com.qmth.examcloud.core.examwork.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.query.Procedure;
import org.springframework.data.repository.query.Param;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamStudentTempEntity;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年7月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface ExamStudentTempRepo
		extends
			JpaRepository<ExamStudentTempEntity, Long>,
			QueryByExampleExecutor<ExamStudentTempEntity>,
			JpaSpecificationExecutor<ExamStudentTempEntity> {

	@Procedure(name = "import_exam_students")
	void processExamStudentTemp(@Param("batch_id") Long batchId);

	void deleteByBatchId(Long batchId);

	@Query("select s from ExamStudentTempEntity s where s.batchId=:batchId and (s.orgId is null or s.courseId is null) order by s.lineNum")
	List<ExamStudentTempEntity> findError(@Param("batchId") Long batchId);

}
